# Nextcloud CheckMK Special Agent
Monitors various aspects of Nextcloud instances like state, quota and disk usage of all users, number of apps with available updates, database php opcache hit rate and so on.
Gives additional information regarding versions of Nextcloud, database, number of storages and active users etc.
Tested only with Nextcloud versions 29/30
Tested only with MariaDB as database backend
The whole plugin is now migrated to the new plugin API version, introduced with CheckMK 2.3
Feel free to report other working environments.


Upgrade from older MKPs (before 3.1.1):

If you upgrade from a already installed MKP version before 3.1.0, you have to re-create your rules for the "Nextcloud Server Information" (reason: some parameter changes combined with the migration to the new plugin API).
Hint: It is always a good idea to create screenshots from all other Nextcloud rules as well.

1. Take a screenshot of your settings in the above mentioned rulesets
2. Assure that you have access to the passwords/tokens you used within the current rules
3. Delete all rules for "Nextcloud Server Information"
4. Install and enable the new MKP
5. Re-create your rules with the previously saved information from steps 1 and 2
6. Apply your changes

Hint: You have to create an app password now for accessing your Nextcloud instance. For this to accomplish login to your Nextcloud server with an administrative user account. Go to "Personal Settings|Security" and take note of the section "Devices & Sessions". Create the app password via clicking the button "create new app password". You may use this password explicitly within the rule or store it first in the password safe of CheckMK.


General installation instructions:
1. Upload and enable the MKP
2. Apply changes
3. Click Setup, search for "Nextcloud"
4. Click on "Nextcloud Server Information" below "Other integrations"
5. Create a new rule and fill in all mandatory information (Hostname, Username, App Password)
6. Adjust all other options to your needs
7. Bind this rule to your Nextcloud host object (e.g. via "Explicit hosts")
8. If you have no host object at all, create a dummy host for this (with no IP or something like 127.0.0.2)
9. Assure that your agents settings for this host object are correct (must contain "Configured API integrations")
10. Apply your changes
11. Execute a service discovery on your Nextcloud host(s) and accept the newly detected services 
12. Feel free to adjust the various parameters for thresholds within the available parameter sections (Setup, "Service monitoring rules" after searching for "Nextcloud")


Version History:
--
|Date|Version|Changes|
|----|-------|-------|
|2025/03/30|3.1.1|Migration to the new plugin API version finished, (hopefully) ready for CheckMK version 2.4
|2023/01/13|2.5.2|Repackaged only to set the minimum required version back to 2.1.0p1, due to serveral user requests|
|2023/01/12|2.5.1|Added versions for apps with available updates|
|2023/01/12|2.4.1|Removed Parameter "token", switched to parameter "app password" only|
|2023/01/12|2.4.0|Integrated Password Store for App Password, some changes for compatibility with NC 28 added|
|2023/11/26|2.3.4|Fixed agent crash if opcache_get_status is disabled by server settings|
|2023/08/16|2.3.3|Fixed some misleading info strings regarding database opcache|
|2023/08/12|2.3.2|MKP now compatible with CheckMK 2.2|
|2023/03/27|2.3.1|Fixed bugs in parameter handling|
|2023/03/23|2.2.1|Adjusted parameter handling|
|||Added check for "free space on disk" (incl. adjustable levels)|
|||Added adjustable levels for "number of files"|
|2023/03/11|2.2.0|Upload initial public release|

Example how the checks look like:
--
![Nextcloud Checks](images/Nextcloud-Checks.png)

Example of the details of the info check:
--
![Nextcloud Info Details](images/Nextcloud-Info-Details.png)

Example when app updates are available:
--
![Nextcloud AppUpdateInfo](images/Nextcloud-Update-Status-WARN.png)
